#-----
#EasySpot - main command
#
#Open easy spot GUI in action panel.
#-----
from __future__ import with_statement
from vcCommand import *
from vcHelpers.Application import *
from vcHelpers.Selection import *
from vcHelpers.Robot2 import *
import os.path, vcMatrix, vcVector, vcSelectionManager

app = getApplication()
sim = getSimulation()
cmd = getCommand()
snap = app.findCommand('interactiveSnap') 
  


def first_state():
  global prop_weld_id, prop_approach, prop_welt_time, prop_thickness, prop_auto_thickness, prop_gun_joint, prop_z_axis, prop_tcp_pos, prop_auto_ori, prop_create,\
  prop_export_csv, prop_import_option, prop_import_mirror, prop_import_csv
  
  #for p in cmd.Properties:
  #  deleteProperty(p)

  prop_approach = cmd.getProperty('Create Spot Statements::Approach')
  if not prop_approach:
    #Create properties
  
    #-----
    # Create spot statements
    #-----
    i = 10
    
    prop_weld_id = createProperty(VC_STRING,'Create Spot Statements::Weld ID')
    prop_weld_id.Value = 'SPOT_1'
    prop_weld_id.Group = i = i+10
    
    prop_approach = createProperty(VC_REAL,'Create Spot Statements::Approach')
    prop_approach.Value = 10
    prop_approach.Group = i = i+10
    
    prop_welt_time = createProperty(VC_REAL,'Create Spot Statements::Weld Time')
    prop_welt_time.Value = 1
    prop_welt_time.Group = i = i+10
    
    prop_thickness = createProperty(VC_REAL,'Create Spot Statements::Thickness')
    prop_thickness.Value = 4
    prop_thickness.Group = i = i+10
    
    prop_auto_thickness = createProperty(VC_BOOLEAN,'Create Spot Statements::Auto Thickness')
    prop_auto_thickness.Value = True
    prop_auto_thickness.Group = i = i+10
    prop_auto_thickness.OnChanged = OnAutoThickness
    prop_thickness.WritableWhenConnected = not prop_auto_thickness.Value
    prop_thickness.WritableWhenDisconnected = not prop_auto_thickness.Value
    
    prop_gun_joint = createProperty(VC_REAL,'Create Spot Statements::Gun Joint')
    prop_gun_joint.Value = 100
    prop_gun_joint.Group = i = i+10
    
    prop_z_axis = createProperty(VC_STRING,'Create Spot Statements::TCP Approach Axis',VC_PROPERTY_STEP)
    prop_z_axis.Value = 'Z+'
    prop_z_axis.StepValues = ['Z+', 'Z-', 'X+', 'X-', 'Y+', 'Y-']
    prop_z_axis.Group = i = i+10
    
    prop_tcp_pos = createProperty(VC_STRING,'Create Spot Statements::TCP Position',VC_PROPERTY_STEP)
    prop_tcp_pos.Value = 'At Click Side'
    prop_tcp_pos.StepValues = ['At Click Side', 'At Flip Side']
    prop_tcp_pos.Group = i = i+10
    
    prop_auto_ori = createProperty(VC_BOOLEAN,'Create Spot Statements::Auto Orientate Points')
    prop_auto_ori.Value = True
    prop_auto_ori.Group = i = i+10
    
    
    prop_create = createProperty(VC_BUTTON,'Create Spot Statements::Create Spots')
    prop_create.Group = i = i+10
    prop_create.OnChanged = createSpotStatements
    
    #-----
    # CSV
    #-----
    i = 10
    
    prop_export_csv = createProperty(VC_BUTTON,'CSV File::Export Spots to CSV')
    prop_export_csv.Group = i = i+10
    prop_export_csv.OnChanged = exportCSV
    
    prop_import_option = createProperty(VC_STRING,'CSV File::Import Duplicate Spots',VC_PROPERTY_STEP)
    prop_import_option.Value = 'Override duplicate spots'
    prop_import_option.StepValues = ['Clear old program', 'Override duplicate spots', 'Rename duplicate spots', 'Skip duplicate spots']
    prop_import_option.Group = i = i+10
    
    prop_import_mirror = createProperty(VC_STRING,'CSV File::Import Mirroring',VC_PROPERTY_STEP)
    prop_import_mirror.Value = 'No mirror'
    prop_import_mirror.StepValues = ['No mirror', 'BASE XZ', 'BASE XY', 'BASE YZ']
    prop_import_mirror.Group = i = i+10
    
    prop_import_csv = createProperty(VC_BUTTON,'CSV File::Import Spots from CSV')
    prop_import_csv.Group = i = i+10
    prop_import_csv.OnChanged = importCSV
    
  #endif
  
  executeInActionPanel()
  
addState( first_state )
    
def OnAutoThickness(prop):
  #Hide/Show Thickness property when AutoThickness is is/isn't used
  global prop_thickness, prop_auto_thickness
  prop_thickness.WritableWhenConnected = not prop_auto_thickness.Value
  prop_thickness.WritableWhenDisconnected = not prop_auto_thickness.Value
  
def createSpotStatements(arg):
  #Create spot statements
  create_cmd = app.findCommand('easyspot_createSpotStatements')
  #create_cmd.recompile()
  create_cmd.execute()
  
def exportCSV(arg):
  #Create spot statements
  export_cmd = app.findCommand('easyspot_exportCSV')
  #export_cmd.recompile()
  export_cmd.execute()
  
def importCSV(arg):
  #Create spot statements
  import_cmd = app.findCommand('easyspot_importCSV')
  #import_cmd.recompile()
  import_cmd.execute()
  
